
; Runtime functions for ontic (DoorsOS version)

        include "userlib.h"
	include "doorsos.h"
	include "graphlib.h"

        xdef _library
        xdef _ti92plus
        xdef _ti89
        xdef runtime@0000
        xdef runtime@0001
        xdef runtime@0002
        xdef runtime@0003
        xdef runtime@0004
        xdef runtime@0005
        xdef runtime@0006
        xdef runtime@0007
        xdef runtime@0008
        xdef runtime@0009
        xdef runtime@000A
        xdef runtime@000B
        xdef runtime@000C
        xdef runtime@000D



; TI92(+), TI89 initialization
runtime@0000:
init_tixx:
;        move.l  4(a7),exit_Address         ; for the  exit (int) function

	rts

; Function DisplayString (char *string)
; Shows a string and waits for a key
; Arguments     string  4(a7)
; Returns       nothing
runtime@0001:
DisplayString:
        movem.l d0-d7/a0-a6,-(a7)
        jsr     graphlib::clr_scr

        move.l  4(a7),a0
        move.w  #4,-(a7)
        move.l  a0,-(a7)
        move.w  #20,-(a7)
        move.w  #20,-(a7)
        jsr     doorsos::DrawStrXY
        add.w   #10,a7

        jsr     userlib::idle_loop

        movem.l (a7)+,d0-d7/a0-a6
        rts


exit_Address	dc.l	0

; Function  exit (int error)
; Exits the program
runtime@0002:
exit:
	move.l	exit_Address,0(a7)
        rts

; Function fprintf (FILE *out, char *fmt, ...)
; formated print to a file, but it's ignored!
runtime@0003:
fprintf:
        rts


; function printf (char *fmt, ...)
; Function ignored!
runtime@0004:
printf:
	rts


; Function calloc (long items, long size)
; Allocates a memoryblock of items*size bytes
; Positions     items   4(a0)
;               size    8(a0)        
; Returns address in d0
runtime@0005:
calloc:
        movem.l d1-d7/a0-a6,-(a7)
        move.l  4(a0),d1
        move.l  8(a0),d2
        mulu.l  d1,d2
        ; Size in the d2
        move.l  d2,-(a7)
        jsr     doorsos::HeapAlloc
        add.w   #4,a7
        tst.w   d0
        beq     OutOfMemory
        doorsos::DEREF d0,a0
        move.l  a0,d0
        movem.l (a7)+,d1-d7/a0-a6
	rts
OutOfMemory:
        clr.l   d0
        movem.l (a7)+,d1-d7/a0-a6
        rts



; Function  strcmp (char *s1, char *s2)
; Compares two strings
; Arguments     s1      4(a7)
;               s2      8(a7)
; Result in d0
runtime@0006:
strcmp:
        movem.l d1-d7/a0-a6,-(a7)
        move.l  4(a7),a0
        move.l  8(a7),a1
        move.l  a1,-(a7)
        move.l  a0,-(a7)
        jsr     doorsos::strcmp
        add.w   #8,a7
        ext.l   d0
        movem.l (a7)+,d1-d7/a0-a6
        rts


; Function fgets (char *buffer, int max, FILE *input)
; Reads a line or max bytes into buffer
; Arguments	buffer		4(a7)
;		max		8(a7)
;		input		12(a7)
; struct file {
;	int handle, offset;
;	};
; Returns  number of bytes red in d0
runtime@0007:
fgets:
	movem.l d1-d7/a0-a6,-(a7)
	move.l  12(a7),a0
	move.l  (a0),d1			; Handle of the TI file
	doorsos::DEREF d1,a1
	move.l  4(a0),d1
	add.l	d1,a1			; Current position
	clr.l	d3			; Nr. of bytes red
	move.l	4(a7),a4		; buffer
	move.l	8(a7),d5

ScanFromFile:
	cmp.l	d5,d3			; max bytes red?
	beq	End_of_fgets

	tst.b	(a1)			; end of file?
	beq	End_of_fgets

	move.b  (a1)+,(a4)+		; copy byte
	add.w	#1,d3			; maxcounter++
	add.l   #1,4(a0)		; new offset in filestructure

	cmpi.b	#13,-1(a4)		; end of line?
	bne	ScanFromFile
	add.l   #1,4(a0)		; skip first byte of this line

End_of_fgets:
	move.l	d3,d0
	movem.l (a7)+,d1-d7/a0-a6
        rts

FILE_STRUCTURES		ds.l   2*10	; 10 Files depth

FolderName		ds.b   10
FileName		ds.b   10
	
; function  fopen (char *file, char *access)
; Opens a file and prepares the filestructure (textfile)
; Only read access is accepted!
; Arguments	file	4(a7)
;		access	8(a7)
; Returns in d0 a pointer to the structure (0 -> error)
runtime@0008:
fopen:
	movem.l	d1-d7/a0-a6,-(a7)
	move.l	8(a7),a0
	cmp.b	#'r',(a0)
	bne	Ignore
	; Open this file
	; Split into folder and file name
	move.l  4(a7),a0
	; Is there a '\'?
Find_Backslash:
	tst.b	(a0)
	beq	No_Backslash
	cmp.b	#'\',(a0)
	beq	Backslash
	add.w	#1,(a0)
	bra	Find_Backslash

No_Backslash:
	; Find file in 'main' folder
	move.l	4(a7),a0
	move.l	a0,-(a7)
	move.w	#$c,-(a7)
	jsr	userlib::FindSymEntry
	add.w	#6,(a0)
	move.l	a0,d0
	tst.l	d0
	beq	Ignore

	; Prepare structure
	bra	Preparestructure

Backslash:
	; Find file in a specific folder
	; A0 points to the '\'!
	move.l	4(a7),a1
	lea	FolderName(PC),a2
CopyFolderName:
	move.b  (a1)+,(a2)+
	cmp.b	#'\',(a1)
	bne	CopyFolderName
	clr.b	(a2)

	lea	FileName(PC),a2
	add.w	#1,a1
CopyFileName:
	move.b	(a1)+,(a2)+
	tst.b	(a1)
	bne	CopyFileName
	clr.b	(a2)

	; Find file
	pea	FolderName(PC)
	move.w	doorsos::FolderListHandle,-(a7)
	jsr	userlib::FindSymEntry
	add.w	#6,a7

	move.l	a0,d0
	tst.l	d0
	beq	Ignore

	pea	FileName(PC)
	move.w	doorsos::SYM_ENTRY.hVal(a0),-(a7)
	jsr	userlib::FindSymEntry
	add.w	#6,a7
	
	move.l	a0,d0
	tst.l	d0
	beq	Ignore

	; File found, prepare structure
Preparestructure:
	lea	FILE_STRUCTURES(PC),a1
FindSpace:
	tst.l	(a1)
	beq	SpaceFound
	add.w	#8,a1
	bra	FindSpace

SpaceFound:
	clr.l	d0
	move.w  doorsos::SYM_ENTRY.hVal(a0),d0
	move.l	d0,(a1)
	doorsos::DEREF d0,a2
	move.w	0(a2),d1
	move.b	1(a2,d1.w),d3
	cmp.b	#$E0,d3			; Is it a textfile?
	beq	Next_Step

	clr.l	(a1)
	clr.l	d0
	bra	Ignore	

Next_Step:
	; Offset into this file
	move.w  #4,4(a1) 
	move.l  a1,d0
	; Prepared structure, now the function can return

Ignore:
	movem.l	(a7)+,d1-d7/a0-a6
        rts


; function  fclose (FILE *file);
; Close a file
; Arguments	file	4(a7)
; returns nothing
runtime@0009:
fclose:
	movem.l a0,-(a7) 
	move.l	4(a7),a0
	clr.l	(a0)+
	clr.l	(a0)
	movem.l	(a7)+,a0
        rts


; Function strlen (char *String)
; Returns the stringlength
; Arguments     String  4(a7)
; Returns length of string in d0
runtime@000A:
strlen:
        movem.l a0,-(a7)
        move.l  4(a7),a0
        clr.l   d0
Length:
        tst.b   (a0)+
        beq     End_strlen
        add.w   #1,d0
        bra     Length        
End_strlen:
        movem.l (a7)+,a0
        rts


; Function  free (void *mem)
; Frees an allocated memoryblock
; Position      mem     4(a7)
; Returns nothing
runtime@000B:
free:
        movem.l d0-d7/a0-a6,-(a7)
        move.l  4(a7),d0         ; Address
        ; Search for the handle
        move.l  doorsos::Heap,a0
        clr.l   d1
FindHandle:
        cmp.l   (a0),d0
        beq     FoundArea
        add.w   #1,d1
        add.w   #4,(a0)
        bra     FindHandle

FoundArea:
        move.w  d1,-(a7)
        jsr     doorsos::HeapFree
        add.w   #2,a7

        movem.l (a7)+,d0-d7/a0-a6
        rts


; Function strcpy (char *Dest, char *source)
; Copies source to dest (string copy)
; Position      source  8(a7)
;               Dest    4(a7)
; Returns nothing
runtime@000C:
strcpy:
        movem.l d0-d7/a0-a6,-(a7)
        move.l  4(a7),a1
        move.l  8(a7),a0
CopyString:
        move.b  (a0),(a1)+
        tst.b   (a0)+
        bne     CopyString
        movem.l (a7)+,d0-d7/a0-a6
        rts


; Function C_Switch
; This function is used to handle a switch block
; called with	d0  - code
; in (a7) is the address of the table
runtime@000D:
c%switch:
	movem.l a0,-(a7) 
        move.l  4(a7),a0
TestLoop:
	tst.l   (a0)
	bne	Check_Valid
; Default label
        move.l  4(a0),4(a7)
	movem.l (a7)+,d0
	rts 

Check_Valid:
        cmp.l   4(a0),d0
	beq	AddressFound
	lea	8(a0),a0
	bra	TestLoop

AddressFound:
        move.l  (a0),4(a7)
	movem.l (a7)+,a0
	rts

        END
