
#include <iostream.h>
#include <fstream.h>
#include <ctype.h>
#include <string.h>

#include "readasm.h"

ReadASM::ReadASM (char *file, char *il[], int DoorsOS)
{
   ifstream  InputFile (file);
   char      InputString[256], NextInputString[256], ic;
   int       i, j;

   DoorsPRGM  = DoorsOS;
   SecondPass = 0;

   strcpy (FileName, file);

   strlwr (FileName);
   i = 0;
   while (FileName[i] != '.') i++;
   j = 0;
   Independend = 0;
   while (il[j] != NULL)
   {
      if (strncmp (il[j], FileName, i) == 0)
      {
         Independend = 1;
         break;
      }
      j++;
   } // while

   start = last     = new LabelList;
   start->next      = NULL;
   start->Item      = NULL;
   start->Position  = UNKNOWN;

   while (1)
   {
      i = 0;
      InputString[0] = '\0';
      while (1)
      {
         ic = InputFile.get ();
         if (ic == EOF || ic == '\n') break;
         InputString[i] = ic;
         InputString[i + 1] = '\0';
         i++;
      } // while

      if (ic == EOF) break;
      if (strlen (InputString) <= 2) continue;
      if (InputString[0] == ';') continue;

      if (!isspace (InputString[0]))
      {
         // Found a function or variable name, add it to the label tree
         InputString[i - 1] = '\0';
         // Check, if for a variable
         j = 0;
         NextInputString[0] = '\0';
         while (1)
         {
            ic = InputFile.get ();
            if (ic == EOF || ic == '\n') break;
            NextInputString[j] = ic;
            NextInputString[j + 1] = '\0';
            j++;
         } // while

         if (strstr (NextInputString, "dc.") != NULL ||
             strstr (NextInputString, "ds.") != NULL)
            last->Variable = 1;
         else {
            if (isupper (InputString[0])) continue;
            last->Variable = 0;
         } // if

         last->Item      = new char[i + 1];
         strcpy (last->Item, InputString);
         last->Position  = UNKNOWN;

         last->next      = new LabelList;
         last            = last->next;
         last->Item      = NULL;
         last->next      = NULL;

      } // if

   } /* while */
} // ReadASM::ReadASM

int ReadASM::Solve (ReadASM *OtherLibs[])
{
   ifstream  InputFile (FileName);
   char      Temp[256], Temp2[256];
   int       i, len, Dep, j;
   LabelList *FC_Entry = NULL, *NObject, *Searcher;
   ReadASM   *CurrentObj;

   if (Independend) return 0;
   while (!InputFile.eof ())
   {
      InputFile.getline (Temp, 256);

      // Now check if a function / variable name was found
      len = strlen (Temp);
      if (len <= 2) continue;
      if (Temp[0] == ';')
         continue;

      if (!isspace (Temp[0]))
      {
         // New label
         Temp[len - 1] = '\0';         // Delete ':'
         Searcher = start;
         while (strcmp (Searcher->Item, Temp) != 0)
            if (Searcher->next->Item != NULL)
               Searcher = Searcher->next;
            else
               break;

         if (strcmp (Searcher->Item, Temp) != 0) continue; // Ignore this local label

         // New FC_Entry
         FC_Entry = Searcher;
         // Found a function / variable

         if (FC_Entry->Variable)
         {
            if (strcmp (FC_Entry->Item, "keywords") == 0)
               FC_Entry->Position = LIB2;
            else if (strcmp (FC_Entry->Item, "opl") == 0)
               FC_Entry->Position = LIB2;
            else
               FC_Entry->Position = PUBLIB;
            FC_Entry = NULL;
         } else if (FC_Entry->Position != LIB2) {
               FC_Entry->Position = LIB2;     // Independend function?
         } else FC_Entry = NULL; // Ignore an independend function
         continue;
      } // if

      // When FC_Entry != NULL, check for a depend function / variable
      if (FC_Entry == NULL) continue;
      // Extract a "label"!

      if (!isspace (Temp[0])) continue;
      j = 0;
      while (isspace (Temp[j])) j++;
      while (!isspace (Temp[j])) j++;
      while (isspace (Temp[j])) j++;

      if (Temp[j] == '#') j++;

      i = j;
      while (Temp[j] != ',' && Temp[j] != '\0')
      {
         Temp2[j - i] = Temp[j];
         Temp2[j - i + 1] = '\0';
         j++;
      } // while

      if (strcmp (FC_Entry->Item, Temp2) == 0) continue;
      i   = 0;
      Dep = -1;
      while (1)
      {
         CurrentObj = OtherLibs[i];
         if (CurrentObj == NULL) break; // Finished with this list
         // Find for functions / variables
         NObject = CurrentObj->start;
         while (NObject->Item != NULL)
         {
            if (strcmp (Temp2, NObject->Item) == 0)
            {
               if (!(CurrentObj->Independend == 1 ||
                   NObject->Position == PUBLIB  ||
                   NObject->Position == LIB2))
                  Dep = 1;

               break;
            } // if
            NObject = NObject->next;
         } // while
         if (Dep != -1) break;
         i++;
      } // while

      // Now decide, where the function has to be
      if (Dep == 1)
         FC_Entry->Position = LIB1;

   } // while
   return 1;
} // ReadASM::Solve

int ReadASM::WritePositions (ofstream& OFile, int Lib)
{
   LabelList *Position = start;
   char Buffer[8];
   char LibName[32];
   int i;

   if (AreYouCMAIN ()) return 0;
   i = 0;
   while (FileName[i] != '.')
   {
      LibName[i] = FileName[i];
      LibName[i + 1] = '\0';
      i++;
   } // while
   strlwr (LibName);

   while (Position->Item != NULL)
   {
      if (Position->Position != Lib)
      {
         sprintf (Buffer, "%04X", Position->LibIndex);
         if (Independend)
         {
            OFile << Position->Item << "\tequ\t" << LibName << "@" << Buffer << "\n";
            Position = Position->next;
            continue;
         }
         switch (Position->Position)
         {
            case LIB1: OFile << Position->Item << "\tequ\tlib1@"
                             << Buffer
                             << "\n";
                       break;
            case LIB2: OFile << Position->Item << "\tequ\tlib2@"
                             << Buffer
                             << "\n";
                       break;
            case PUBLIB: OFile << Position->Item << "\tequ\tpublib@"
                               << Buffer
                               << "\n";
                         break;
            default: break;
         } // switch
      } // if
      Position = Position->next;
   } // while
   return 1;
} // ReadASM::WritePositions


int ReadASM::WriteDefinitions (ofstream& OFile, int Lib, int& Number)
{
   LabelList *Position = start;
   char Buffer[8];
   int i;

   if (AreYouCMAIN ()) return 0;
   i = 0;
   while (Position->Item != NULL)
   {
      if (Independend)
      {
         Position->LibIndex = i;
         i++;
         // The writefunction routine will write the definitions!
      } // if
      if (Position->Position == Lib)
      {
         Position->LibIndex = Number;
         sprintf (Buffer, "%04X", Number);
         Number++;
         switch (Lib)
         {
            case LIB1: OFile << "\txdef\tlib1@"
                             << Buffer
                             << "\n";
                       break;
            case LIB2: OFile << "\txdef\tlib2@"
                             << Buffer
                             << "\n";
                       break;
            case PUBLIB: OFile << "\txdef\tpublib@"
                               << Buffer
                               << "\n";
                         break;
            default: break;
         } // switch
      } // if
      Position = Position->next;
   } // while
   return 1;
} // ReadASM::WriteDefinitions

// This function writes the code to the output and fixes two bugs
int ReadASM::WriteFunctions (ofstream& OFile, int Lib, ReadASM *il[])
{
   LabelList *Position = NULL, *Entry;
   char InputString[256], Buffer[16], LibName[16];
   ifstream InputFile (FileName);
   ofstream *OutFile;
   int len, i;

   if (AreYouCMAIN ()) return 0;

   if (Independend)
   {
      i = 0;
      while (FileName[i] != '.')
      {
         Buffer[i] = LibName[i] = FileName[i];
         Buffer[i + 1] = LibName[i + 1] = '\0';
         i++;
      } // while
      strcat (Buffer, ".asm");
      strlwr (LibName);
      OutFile = new ofstream (Buffer);
      if (DoorsPRGM)
         *OutFile << "; [auto libcode]\n\n\txdef _library\n\txdef _ti92plus\n\txdef _ti89\n\tinclude \"onticsd.h\"\n";
      else
         *OutFile << "; [auto libcode]\n\n\txdef _library\n\tinclude \"onticsf.h\"\n";
      Entry = start;
      while (Entry->Item != NULL)
      {
         sprintf (Buffer, "%04X", Entry->LibIndex);
         *OutFile << "\txdef\t" << LibName << "@" << Buffer << "\n";
         Entry = Entry->next;
      } // while
      i = 0;
      while (il[i] != NULL)
      {
         if (il[i] != this)
            il[i]->WritePositions (*OutFile, EVERYFUNCTION);
         i++;
      } // while

      Entry = start;
      while (!InputFile.eof ())
      {
         InputFile.getline (InputString, 256);
         if (strstr (InputString, "END")) break;
         if (InputString[0] == ';') continue;
         if (strcmp (InputString, "\tasl.l\t#11,d0") == 0)
             strcpy (InputString, "\tmulu.l\t#2048,d0");

         if (strcmp (InputString, "\tmove.l\t#45,lastch") == 0)
         {
             InputFile.getline (InputString, 256);
             strcpy (InputString, "\tcmp.l\t#45,lastch");
         } // if

         if (!isspace (InputString[0]) && strlen (InputString) > 0)
         {
            InputString[strlen (InputString) - 1] = '\0';
            if (strcmp (InputString, Entry->Item) == 0)
            {
               sprintf (Buffer, "%04X", Entry->LibIndex);
               *OutFile << LibName << "@" << Buffer << ":\n" << InputString << ":\n";
               Entry = Entry->next;
               continue;
            } // if
         } // if
         *OutFile << InputString << "\n";
      } // while
      if (!DoorsPRGM)
         *OutFile << "_library dc.b \"" << LibName << "\",0\n\tEND";
      delete OutFile;
      return 0;
   } // if
   OFile << "\tEVEN\n";
   while (!InputFile.eof ())
   {
      InputFile.getline (InputString, 256);

      if (strstr (InputString, "END") != NULL) break;
      if (InputString[0] == ';') continue;
      if (strcmp (InputString, "\tasl.l\t#11,d0") == 0)
          strcpy (InputString, "\tmulu.l\t#2048,d0");

      if (strcmp (InputString, "\tmove.l\t#45,lastch") == 0)
      {
          InputFile.getline (InputString, 256);
          strcpy (InputString, "\tcmp.l\t#45,lastch");
      } // if

      if (!isspace (InputString[0]))
      {
         Entry = start;
         len = strlen (InputString);
         InputString[len - 1] = '\0';
         while (Entry->Item != NULL)
         {
            if (strcmp (InputString, Entry->Item) == 0)
            {
               Position = Entry;
               if (Lib != Entry->Position)
               {
                  Position = NULL;
                  break;
               } // if

               sprintf (Buffer, "%04X", Position->LibIndex);
               switch (Lib)
               {
                  case LIB1: OFile << "\tEVEN\n\nlib1@"
                                   << Buffer
                                   << ":\n" << InputString << ":\n";
                             break;
                  case LIB2: OFile << "\tEVEN\n\nlib2@"
                                   << Buffer
                                   << ":\n" << InputString << ":\n";
                             break;
                  case PUBLIB: if (SecondPass)
                                  OFile << "; initialization of " << InputString << "\n";
                               else
                                  OFile << "\tEVEN\n\npublib@"
                                        << Buffer
                                        << ":\n" << InputString << ":\n";
                               break;
                  default: break;
               } // switch
               break;
            } // if
            if (Entry->next->Item == NULL)
            {
               // Local label
               if (!SecondPass)
                  OFile << InputString << ":\n";
               break;
            } // if
            Entry = Entry->next;
         } // while
         continue;
      } // if
      if (Position == NULL)
         continue;

      if (Position->Position == Lib)
        if (!SecondPass)
           OFile << InputString << "\n";
        else
          if (isspace (InputString[0])) OFile << InputString << "\n";
   } // while
   SecondPass = 0;
   return 1;
} // ReadASM::WriteFunctions

int ReadASM::GetFunctions ()
{
   LabelList *Current = start;
   int i = 0;

   if (Independend) return 0;
   while (Current->Item != NULL)
   {
      i++;
      Current = Current->next;
   }

   return i;
} // ReadASM::GetFunctions

int ReadASM::MovedFunctions (int Lib)
{
   LabelList *Current = start;
   int i = 0;

   if (Independend) return 0;
   while (Current->Item != NULL)
   {
      if (Current->Position == Lib) i++;
      Current = Current->next;
   } // while
   return i;
} // ReadASM::MovedFunctions

ReadASM::~ReadASM ()
{
   // Dispose tree
   LabelList *Current, *Nxt;
   Current = start;
   while (Current != NULL)
   {
      Nxt = Current->next;
      if (Current->Item != NULL) delete[] Current->Item;
      delete Current;
      Current = Nxt;
   } // while
} // ReadASM::~ReadASM


